// ignore_for_file: lines_longer_than_80_chars, deprecated_member_use

import 'package:flutter/material.dart';
import 'package:flutter/services.dart';

import '../widgets/text_formx_field.dart';

///
extension TextFormxFieldCopyWith on TextFormxField {
  /// Creates a copy of this [TextFormxField] but with the given fields.
  TextFormxField copyWith({
    Key? key,
    GlobalKey<FormFieldState<String>>? fieldKey,
    TextEditingController? controller,
    String? initialValue,
    FocusNode? focusNode,
    InputDecoration? decoration,
    TextInputType? keyboardType,
    TextCapitalization? textCapitalization,
    TextInputAction? textInputAction,
    TextStyle? style,
    StrutStyle? strutStyle,
    TextDirection? textDirection,
    TextAlign? textAlign,
    TextAlignVertical? textAlignVertical,
    bool? autofocus,
    bool? readOnly,
    ToolbarOptions? toolbarOptions,
    bool? showCursor,
    String? obscuringCharacter,
    bool? obscureText,
    bool? autocorrect,
    SmartDashesType? smartDashesType,
    SmartQuotesType? smartQuotesType,
    bool? enableSuggestions,
    MaxLengthEnforcement? maxLengthEnforcement,
    int? maxLines,
    int? minLines,
    bool? expands,
    int? maxLength,
    ValueChanged<String>? onChanged,
    GestureTapCallback? onTap,
    TapRegionCallback? onTapOutside,
    VoidCallback? onEditingComplete,
    ValueChanged<String>? onFieldSubmitted,
    FormFieldSetter<String>? onSaved,
    FormFieldValidator<String>? validator,
    List<TextInputFormatter>? inputFormatters,
    bool? enabled,
    double? cursorWidth,
    double? cursorHeight,
    Radius? cursorRadius,
    Color? cursorColor,
    Brightness? keyboardAppearance,
    EdgeInsets? scrollPadding,
    bool? enableInteractiveSelection,
    TextSelectionControls? selectionControls,
    InputCounterWidgetBuilder? buildCounter,
    ScrollPhysics? scrollPhysics,
    Iterable<String>? autofillHints,
    AutovalidateMode? autovalidateMode,
    ScrollController? scrollController,
    String? restorationId,
    bool? enableIMEPersonalizedLearning,
    MouseCursor? mouseCursor,
    EditableTextContextMenuBuilder? contextMenuBuilder,
    // SpellCheckConfiguration? spellCheckConfiguration,
    // TextMagnifierConfiguration? magnifierConfiguration,
    // UndoHistoryController? undoController,
    // AppPrivateCommandCallback? onAppPrivateCommand,
    // bool? cursorOpacityAnimates,
    // ui.BoxHeightStyle? selectionHeightStyle,
    // ui.BoxWidthStyle? selectionWidthStyle,
    // DragStartBehavior? dragStartBehavior,
    // ContentInsertionPoint? contentInsertionConfiguration,
    // Clip? clipBehavior,
    // bool? scribbleEnabled,
    // bool? canRequestFocus,
  }) {
    return TextFormxField(
      tag,
      key: key ?? this.key,
      fieldKey: fieldKey ?? this.fieldKey,
      controller: controller ?? this.controller,
      initialValue: initialValue ?? this.initialValue,
      focusNode: focusNode ?? this.focusNode,
      decoration: decoration ?? this.decoration,
      keyboardType: keyboardType ?? this.keyboardType,
      textCapitalization: textCapitalization ?? this.textCapitalization,
      textInputAction: textInputAction ?? this.textInputAction,
      style: style ?? this.style,
      strutStyle: strutStyle ?? this.strutStyle,
      textDirection: textDirection ?? this.textDirection,
      textAlign: textAlign ?? this.textAlign,
      textAlignVertical: textAlignVertical ?? this.textAlignVertical,
      autofocus: autofocus ?? this.autofocus,
      readOnly: readOnly ?? this.readOnly,
      toolbarOptions: toolbarOptions ?? this.toolbarOptions,
      showCursor: showCursor ?? this.showCursor,
      obscuringCharacter: obscuringCharacter ?? this.obscuringCharacter,
      obscureText: obscureText ?? this.obscureText,
      autocorrect: autocorrect ?? this.autocorrect,
      smartDashesType: smartDashesType ?? this.smartDashesType,
      smartQuotesType: smartQuotesType ?? this.smartQuotesType,
      enableSuggestions: enableSuggestions ?? this.enableSuggestions,
      maxLengthEnforcement: maxLengthEnforcement ?? this.maxLengthEnforcement,
      maxLines: maxLines ?? this.maxLines,
      minLines: minLines ?? this.minLines,
      expands: expands ?? this.expands,
      maxLength: maxLength ?? this.maxLength,
      onChanged: onChanged ?? this.onChanged,
      onTap: onTap ?? this.onTap,
      onTapOutside: onTapOutside ?? this.onTapOutside,
      onEditingComplete: onEditingComplete ?? this.onEditingComplete,
      onFieldSubmitted: onFieldSubmitted ?? this.onFieldSubmitted,
      onSaved: onSaved ?? this.onSaved,
      validator: validator ?? this.validator,
      inputFormatters: inputFormatters ?? this.inputFormatters,
      enabled: enabled ?? this.enabled,
      cursorWidth: cursorWidth ?? this.cursorWidth,
      cursorHeight: cursorHeight ?? this.cursorHeight,
      cursorRadius: cursorRadius ?? this.cursorRadius,
      cursorColor: cursorColor ?? this.cursorColor,
      keyboardAppearance: keyboardAppearance ?? this.keyboardAppearance,
      scrollPadding: scrollPadding ?? this.scrollPadding,
      enableInteractiveSelection:
          enableInteractiveSelection ?? this.enableInteractiveSelection,
      selectionControls: selectionControls ?? this.selectionControls,
      buildCounter: buildCounter ?? this.buildCounter,
      scrollPhysics: scrollPhysics ?? this.scrollPhysics,
      autofillHints: autofillHints ?? this.autofillHints,
      autovalidateMode: autovalidateMode ?? this.autovalidateMode,
      scrollController: scrollController ?? this.scrollController,
      restorationId: restorationId ?? this.restorationId,
      enableIMEPersonalizedLearning:
          enableIMEPersonalizedLearning ?? this.enableIMEPersonalizedLearning,
      mouseCursor: mouseCursor ?? this.mouseCursor,
      contextMenuBuilder: contextMenuBuilder ?? this.contextMenuBuilder,
      // spellCheckConfiguration: spellCheckConfiguration ?? this.spellCheckConfiguration,
      // magnifierConfiguration: magnifierConfiguration ?? this.magnifierConfiguration,
      // undoController: undoController ?? this.undoController,
      // onAppPrivateCommand: onAppPrivateCommand ?? this.onAppPrivateCommand,
      // cursorOpacityAnimates: cursorOpacityAnimates ?? this.cursorOpacityAnimates,
      // selectionHeightStyle: selectionHeightStyle ?? this.selectionHeightStyle,
      // selectionWidthStyle: selectionWidthStyle ?? this.selectionWidthStyle,
      // dragStartBehavior: dragStartBehavior ?? this.dragStartBehavior,
      // contentInsertionConfiguration: contentInsertionConfiguration ?? this.contentInsertionConfiguration,
      // clipBehavior: clipBehavior ?? this.clipBehavior,
      // scribbleEnabled: scribbleEnabled ?? this.scribbleEnabled,
      // canRequestFocus: canRequestFocus ?? this.canRequestFocus,
    );
  }
}
